import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/config/const.dart';
import 'package:flutter_mylibrary/utils/utils.dart';
import 'package:flutter_mylibrary/widget/widget_template.dart';
import '../flutter_mylibrary.dart';
import 'base_view_state.dart';

mixin BaseRequestModelController<T> on BaseViewState{

  T data;


  void refreshData(){
    request((httpData) {
      this.data = httpData.data;
      onCompleted(this.data);
      setIdle();
      refreshController.finishRefresh();
    });

  }

  onCompleted(T data) {}

  ///获取一个公共的刷新控件
  Widget getEasyRefreshWidget({
    ScrollController scrollController,
    Widget footWidget,
    Widget emptyWidget,
    ViewStateModelWidgetListBuilder<T> widgetListBuilder,
    ViewStateModelWidgetBuilder<T> widgetBuilder,
    Widget busyWidget,
    bool showErrorWidget = true,
    bool showEmptyWidget = true,
    bool showBusyWidget = true,
    Function loadMore,
  }){
    return buildBaseEasyRefresh<T>(
        data: data,
        scrollController: scrollController,
        footWidget: footWidget,
        emptyWidget: emptyWidget,
        widgetListBuilder: widgetListBuilder,
        widgetBuilder: widgetBuilder,
        busyWidget: busyWidget,
        showBusyWidget: showBusyWidget,
        showEmptyWidget: showEmptyWidget,
        showErrorWidget: showErrorWidget,
        onLoad: loadMore,
        onRefresh: (){
          refreshData();
        }
    );
  }



}