import 'package:flutter_mylibrary/base/base_view_state.dart';
import 'package:flutter_mylibrary/http/exception/http_error.dart';
import 'package:get/get_state_manager/src/simple/get_controllers.dart';
import 'package:get/get.dart';

///getx的页面状态基类
abstract class BaseViewStateGetxController extends GetxController with BaseViewState{


  void setIdle() {
    viewState = ViewState.idle;
    refresh();
  }

  void setBusy() {
    viewState = ViewState.busy;
    refresh();
  }


  void setError(HttpError httpError) {
    viewState = ViewState.error;
    this.httpError = httpError;
    onError(httpError);
    refresh();
  }


}